;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;script .GET Beta
;version 0.01.011 Beta
;release date: 2003-12-02
;Project manager: Urgo
;Coders: Urgo, grimace, knight
;email spam@dotGET.org
;url http://dotGET.org
;dotGET.mrc: Core Script Files
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

on *:load: { 
  if ($server == $null) {
    set %wait.connect 1 | server irc.dotGET.net 6669
    echo -s .GET needs to be on an irc server to load.. please wait until your mIRC gets connected
  }
  else { dotGETLoad }
}

alias dotGETLoad {
  dotGET.scriptcheck 
  load -rs " $+ $scriptdir $+ dotGET-db.mrc $+ "
  load -rs " $+ $scriptdir $+ dotGET-setup.mrc $+ "
  load -rs " $+ $scriptdir $+ dotGET-rsearch.mrc $+ "
  load -rs " $+ $scriptdir $+ dotGET-mysearch.mrc $+ "
  load -rs " $+ $scriptdir $+ dotGET-queue.mrc $+ "
  load -rs " $+ $scriptdir $+ dotGET-misc1.mrc $+ "

  set %dotGET.version.name .GET
  set %dotGET.version.number 0.01.011
  set %dotGET.version.type Beta
  set %dotGET.installdate $adate
  set %dotGET.searchinprogress 0
  set %dotGET.disabled 0
  set %dotGET.searchedlast $calc($ctime - 20)
  if $version < 5.81 {
    write -il1 dotGET\dotGET.status.dat 9,1WARNING: YOU ARE USING MIRC $version $+ .  .GET requires at least mIRC version 5.82 to run correctly.  Visit http://www.mirc.com to upgrade
    echo 9,1WARNING: YOU ARE USING MIRC $version $+ .  .GET requires at least mIRC version 5.82 to run correctly.  Visit http://www.mirc.com to upgrade
    .msg $me 9,1WARNING: YOU ARE USING MIRC $version $+ .  .GET requires at least mIRC version 5.82 to run correctly.  Visit http://www.mirc.com to upgrade 
  }
  set %dotGET.searchedlast $calc($ctime - 20)

  if $readini dotGET\dotGET.data main datachan == $null { writeini dotGET\dotGET.data main datachan #.GET }
  if $readini dotGET\dotGET.data main chatchan == $null { writeini dotGET\dotGET.data main chatchan #dotGET }
  if $readini dotGET\dotGET.data main dataon == $null { writeini dotGET\dotGET.data main dataon 1 }
  if $readini dotGET\dotGET.data main chaton == $null { writeini dotGET\dotGET.data main chaton 1 }
  if $readini dotGET\dotGET.data main datahide == $null { writeini dotGET\dotGET.data main datahide 1 }
  if $readini dotGET\dotGET.data share1 path == $null { writeini dotGET\dotGET.data share1 path Empty }
  if $readini dotGET\dotGET.data share2 path == $null { writeini dotGET\dotGET.data share2 path Empty }
  if $readini dotGET\dotGET.data share3 path == $null { writeini dotGET\dotGET.data share3 path Empty }
  if $readini dotGET\dotGET.data share4 path == $null { writeini dotGET\dotGET.data share4 path Empty }
  if $readini dotGET\dotGET.data share5 path == $null { writeini dotGET\dotGET.data share5 path Empty }
  if $readini dotGET\dotGET.data share6 path == $null { writeini dotGET\dotGET.data share6 path Empty }
  if $readini dotGET\dotGET.data share7 path == $null { writeini dotGET\dotGET.data share7 path Empty }
  if $readini dotGET\dotGET.data share8 path == $null { writeini dotGET\dotGET.data share8 path Empty }


  set %dotGET.datachan $readini dotGET\dotGET.data main datachan
  set %dotGET.chatchan $readini dotGET\dotGET.data main chatchan
  set %dotGET.maxtosend 1000
  set %dotGET.maxtosend.search 1000
  set %dotGET.maxtosend.filelist 2500
  if %dotGET.maxresultsrequested == $null { set %dotGET.maxresultsrequested 5000 }
  set %dotGET.net $gettok($server,$calc($gettok($server,0,46) - 1) $+ -,46)
  .timer 1 1 dotGETautojoin
  .timer 1 3 .msg %dotGET.datachan %dotGET.version.name Version %dotGET.version.number $dotGET.verhash $+ $dotGET-filecheck %dotGET.version.type Loaded - mIRC Version $version
  .rlevel dotGETblocked
  .ial on
  .ctcps on
  .raw on
  .timerdotGETbreakfix 0 900 dotGET.BreakFix

  if (%dotGET.usealtip == 1) { .localinfo -h | .timer 1 2 dotGET.setip }
  elseif (%dotGET.usealtip == 2) { set %dotGET.getmyip 1 | set %dotGET.myip 0.0.0.0 | .timer 1 1 .dns $me }
  else { .localinfo -u | .timer 1 10 dotGET.setip }

  if %dG.installdate == $null { if %dotGET.installdate == $null { set %dG.installdate $adate } | else { set %dG.installdate %dotGET.installdate } }
  if %dG.installtime == $null { if %dotGET.installtime == $null { set %dG.installtime $ctime } | else { set %dG.installtime %dotGET.installtime } }
  if %dG.origver == $null { if %dotGET.origver == $null { set %dG.origver %dotGET.version.number %dotGET.version.type } | else { set %dG.origver %dotGET.origver } }

  if $readini(dotGET\dotGET.data,stats,requested) != $null { } | elseif (%dotGET.counter.request == $null) { writeini dotGET\dotGET.data stats requested 0 } | else writeini dotGET\dotGET.data stats requested %dotget.counter.request | unset %dotGET.counter.request
  if $readini(dotGET\dotGET.data,stats,sent) != $null { } | elseif (%dotGET.counter.send == $null) { writeini dotGET\dotGET.data stats sent 0 } | else writeini dotGET\dotGET.data stats sent %dotget.counter.send | unset %dotGET.counter.send
  if $readini(dotGET\dotGET.data,stats,processed) != $null { } | elseif (%dotGET.counter.search == $null) { writeini dotGET\dotGET.data stats processed 0 } | else writeini dotGET\dotGET.data stats processed %dotget.counter.search | unset %dotGET.counter.search

  write -il1 dotGET\dotGET.status.dat dotGET v. $+ %dotGET.version.number %dotGET.version.type on mIRC $version Loaded - $fulldate
  write -il1 dotGET\dotGET.status.dat Listening...

  dotGETMainSetup
  dotGETSetupShares

  dialog -m dotGETsplash dotGETsplash

  if ($hget(files) != $null) { haltdef } | else { hmake files 100 }
  if ($hget(shared) != $null) { haltdef } | else { hmake shared 100 }

  ;disabled until code is fully written
  ;.timerdotGETcfw 1 5 dotGET.checkforfirewall
  if (%dotGET.firewall == 0) { unset %dotGET.firewall) }
  ;will be ready in the next version probally

  set %dotGET.load 1
  dotgetupdate 
}

on *:connect:{
  if (%wait.connect) { unset %wait.connect | dotGETLoad }
  .ial on
  .ctcps on
  .raw on
  dotgetupdate 
  if (%dotGET.firewall == 0) { unset %dotGET.firewall) }
  if (%dotGET.usealtip == 1) { .localinfo -h | .timer 1 2 dotGET.setip }
  elseif (%dotGET.usealtip == 2) { set %dotGET.getmyip 1 | set %dotGET.myip 0.0.0.0 | .timer 1 1 .dns $me }
  else { .localinfo -u | .timer 1 10 dotGET.setip }
  dotGETautojoin
  set %dotGET.searchinprogress 0
  dotGETtimercheck
  .timer 1 120 dotGETdbconsistincy
  .rlevel dotGETblocked
  dotGET.checkfordisabled
  if ($lines(dotGET\dotGET.queue) > 0) { .timerdotGETSend 0 30 dotGETqueue.send }
  .timerdotGETbreakfix 0 900 dotGET.BreakFix
  .timerlogcheck 0 3600 dotGETStatusLog
  write -il1 dotGET\dotGET.status.dat New Session on $gettok($server,$calc($gettok($server,0,46) - 1) $+ -,46) starting at $fulldate 
  set %dotGET.net $gettok($server,$calc($gettok($server,0,46) - 1) $+ -,46)
  if ($hget(files) != $null) { haltdef } | else { hmake files 100 }
  if ($hget(shared) != $null) { haltdef } | else { hmake shared 100 }
}

alias dotGETautojoin {
  if ($readini dotGET\dotGET.data main chaton == 1) { join $readini dotGET\dotGET.data main chatchan }
  if ($readini dotGET\dotGET.data main dataon == 1) { join $readini dotGET\dotGET.data main datachan }

  if ($lines(dotGET\dotGET.all.db1) == $null) { set %dotGET.shared 0 } | else { set %dotGET.shared $lines(dotGET\dotGET.all.db1) }
  if (%dotGET.sizeshared == $null) { set %dotGET.sizeshared 0 } | else { }

  set %dotGET.datachan $readini dotGET\dotGET.data main datachan
  set %dotGET.chatchan $readini dotGET\dotGET.data main chatchan
  if (%dotGET.load) { unset %dotGET.load | halt }
  .timerstat 1 10 dotGETStatsR 
}

;files = total number of files shared
alias dotGET.filesadd {
  set %dotGET.global.files 0
  var %a = 1 
  while ($hget(files,%a).item) { 
    ;    echo -a $hget(files,%a).item sharing $hget(files,$hget(files,%a).item) files
    inc %dotGET.global.files $hget(files,$hget(files,%a).item)
    inc %a 
  }
  ;  echo -a $me sharing %dotGET.shared files
  inc %dotGET.global.files %dotGET.shared
}

;shared = total size of all files shared
alias dotGET.sharedadd {
  set %dotGET.global.shared 0
  var %b = 1 
  while ($hget(shared,%b).item) { 
    ;    echo -a $hget(shared,%b).item sharing $dotGETresize($hget(shared,$hget(shared,%b).item))
    inc %dotGET.global.shared $hget(shared,$hget(shared,%b).item)
    inc %b
  }
  ;  echo -a $me sharing $dotGETresize(%dotGET.sizeshared)
  inc %dotGET.global.shared %dotGET.sizeshared
}

alias dotGETStatsR {
  if ($me ison %dotGET.datachan) { .msg %dotGET.datachan .updatestats $dotGETF(%dotGET.shared) $round($dotGETF(%dotGET.sizeshared),0) $send(0)) $+ / $+ $dotGETF( [ $readini dotGET\dotGET.data main sendseach ] ) $+ / $+ $dotGETF( [ $readini dotGET\dotGET.data main sendsmax ] ) $dotGETF($lines(dotGET\dotGET.queue)) $+ / $+ $dotGETF( [ $readini dotGET\dotGET.data main queuesmax ] ) }
}

on *:part:%dotGET.datachan: { 
  hdel files $nick
  hdel shared $nick
}

on *:quit:{ 
  if ($hget(files, $+ $nick $+ ) == $null) { halt }
  if ($hget(shared, $+ $nick $+ ) == $null) { halt }
  var %i = 0 
  while ($comchan($nick,%i)) { 
    inc %i 1 
    if ($comchan($nick,%i) == %dotGET.datachan) {
      hdel files $nick
      hdel shared $nick
    }
  } 
}

on *:nick:{
  if ($hget(files,$nick) == $null) { halt }
  if ($hget(shared,$nick) == $null) { halt } 
  elseif ($comchan($nick,%dotGET.datachan) != $null ) { 
    hadd files $newnick $hget(files,$nick) 
    hadd shared $newnick $hget(shared,$nick) 
    hdel files $nick 
    hdel shared $nick 
  }
  else { halt }
}

alias dotGETViewStats {
  if (%dotGET.viewnick == $me) { echo -a You are sharing %dotGET.shared files, totaling $dotGETResize(%dotGET.sizeshared) $+ . | halt }
  if ($hget(files,%dotGET.viewnick) == $null) { echo -a There are no statistics recorded for this user. }
  else { echo -a %dotGET.viewnick is sharing $hget(files,%dotGET.viewnick) files, totaling $dotGETResize($hget(shared,%dotGET.viewnick)) $+ . }
}

raw 324:* {
  if ($2 == $readini dotGET\dotGET.data main datachan) {
    dotGETd .GET ready
    if ($readini dotGET\dotGET.data main datahide != 0) {
      window -h $2
    }
  }
}

dialog dotGETsplash {
  title "Installing .GET"
  size -1 -1 148 150
  option dbu
  text ".GET is currently in beta stages which means that it is still being developed and tested for bugs.", 1, 9 84 129 15, center
  button "OK", 2, 53 131 37 12, ok
  text "Thank you for trying out .GET", 3, 31 4 73 9
  text "To use:", 4, 7 27 21 8
  text "(pronounced as dotGET)", 5, 37 13 60 11
  text "If you find a bug, please report it in #dotGET on irc.dotGET.net", 6, 31 102 75 19, center
  text "1. Set a folder(s) to share with other dotGET users", 7, 7 37 130 7
  text "2. Modify the Main Setup for optimal use", 8, 7 44 131 8
  text "3. After configuration, right click in your mIRC window, ", 9, 7 52 131 8
  text "go to .GET and then choose 'Search' to began searching.", 10, 12 59 128 14
}

menu * {
  [ $chr(46) $+ GET ]
  .[ $chr(46) $+ GET ] Support Network
  ..Open in New Window (mirc 6 and higher) { server -m irc.dotget.net -j #dotGET }
  ..Open in this Window { server irc.dotget.net }
}


menu @.GET {
  .Clear Window { clear @.GET }
}

menu status,channel,menubar,@.GET {
  [ $chr(46) $+ GET ]
  .Search: dotGETSearch
  .Setup
  ..Main Setup: dotGETMainSetup
  ..Database Setup: dotGETSetupShares
  ..Data Chan = %dotGET.datachan
  ...Use Default Data Chan (#.GET): { set %dotGET.datachan #.GET | writeini dotGET\dotGET.data main datachan #.GET }
  ...Use This channel as Data Chan ( $+ $active $+ ): { if ($active ischan) { set %dotGET.datachan $active | writeini dotGET\dotGET.data main datachan $active } }
  ;..Firewall/Router Checker:dotGET.checkforfirewall
  .Queues
  ..Check my queues on other servers: dotGET.checkqueues
  ..View Outgoing Queue List: { run notepad dotGET\dotGET.queue }
  .Documentation
  ..Whats New: run dotGET\dotGETversions.txt
  ..FAQ: url -an http://dotGET.org/faqs.html
  .Unload .GET: dotGETUnload
  .Say Version: dotGETsv
  .-
  .Stats: dotGETStats
}

menu nicklist,query {
  [ $chr(46) $+ GET ]
  .Search .GET: dotGETSearch
  .Browse Users Files: { dotGET.browse $1 }
  .View Users Stats: { set %dotGET.viewnick $1 | dotGETViewStats }
  .Say Version { dotGETsv }
}

alias dotGETUnload {
  dialog -m dotGETUnload dotGETUnload
}

dialog dotGETUnload {
  title "Unload .GET"
  size -1 -1 112 58
  option dbu
  text "Are you sure you want to Unload dotGET?", 1, 24 10 59 17, center
  button "Yes", 2, 15 38 37 12, default ok
  button "No", 3, 59 38 37 12, default cancel
}

on *:dialog:dotGETUnload:sclick:*:{
  if ($did == 2) {
    dotGETUnloadYes
  }
}

alias dotGETUnloadYes {
  .timerdotGETbreakfix off 
  .timerdotget.setip off 
  .timerdotgetqueueupdateline off 
  .timerdotGETSend off 
  .timerdotGETTimer1 off 
  .timerdotGETTimer2 off 
  .timerdotGETupdateline off
  if ($server == $null) { echo -a [.GET] %dotGET.version.number %dotGET.version.type Unloaded } 
  else { .msg %dotGET.datachan .GET %dotGET.version.number %dotGET.version.type Unloaded }
  sockclose dotGETSendQueues 
  sockclose dotGETSendSearch 
  sockclose dotGETQueues 
  sockclose dotGETSearch 
  unload -rs dotget\dotGET-db.mrc
  unload -rs dotget\dotGET-setup.mrc
  unload -rs dotget\dotGET-rsearch.mrc
  unload -rs dotget\dotGET-mysearch.mrc
  unload -rs dotget\dotGET-queue.mrc
  unload -rs dotget\dotGET-misc1.mrc
  unload -rs dotget\dotGET.mrc
}

alias dotGET.scriptcheck {
  var %i = 1
  while (%i <= $script(0)) {
    var %current = $script(%i)
    if ((%current == $mircdir $+ dotget.mrc) || (%current == $mircdir $+ dotget2.mrc) || (%current == $mircdir $+ dotget3.mrc) || (%current == $mircdir $+ dotget\dotget2.mrc) || (%current == $mircdir $+ dotget\dotget3.mrc)) {
      unload -rs %current
    }
    inc %i
  }
}

on *:SOCKOPEN:dotGETUpdate: {
  sockwrite -nt $sockname GET /versioncheck/current HTTP/1.1
  sockwrite -nt $sockname Host: update.dotget.net
  sockwrite -nt $sockname Referer: $server
  sockwrite -nt $sockname User-Agent: .GET/ $+ %dotGET.version.number (mIRC $version $+ )
  sockwrite -t $sockname $str($crlf,2)
}

alias dotgetupdate {
  sockclose dotgetUpdate
  sockopen dotgetUpdate dotget.net 80
}
on *:sockread:dotGETUpdate:{
  if ($sockerr > 0) { write -il1 dotGET\dotGET.status.dat Error occured while connected to the server | dotGETd Error occured while connected to the server | return }
  :nextread
  sockread %dotGETUpdate

  if ($remove(%dotGETUpdate,.) isnum) { 
    if (%dotGETUpdate > %dotGET.version.number) {
      if $dialog(dotGETUpdate) == $null { dialog -m dotGETUpdate dotGETUpdate }
    }
  }
  if ($sockbr == 0) return
  goto nextread
  if ($sockbr == 0) return
  if (%dotGET.update.lastline == $null) %dotGET.updates.lastline = -
}
